﻿(function () {
    var ZoomableProperty = WinJS.Class.define(function () { }, {
        initialize: function () { },
        beginZoom: function () { },
        configureForZoom: function (isZoomedOut, isCurrentView, triggerZoom, prefetchedPages) { },
        endZoom: function (isCurrentView) { },
        getCurrentItem: function () {
            var result;
            result = {
                item: {},
                position: {
                    left: 0,
                    top: 0,
                    width: 0,
                    height: 0
                }
            };
            return WinJS.Promise.wrap(result);
        },
        getPanAxis: function () { },
        handlePointer: function (pointerId) { },
        positionItem: function (item, position) { },
        setCurrentItem: function (x, y) { }
    });

    //セマンティックズームを利用するためのビュークラスです。
    var ZoomInCategoryList = WinJS.Class.define(function (element, options) {
        this.zoomableView = new ZoomableProperty();
    });

    var ZoomOutCategoryList = WinJS.Class.define(function (element, options) {
        var that = this;
        this.zoomableView = new ZoomableProperty();
        element.addEventListener('click', function (e) {
            if (e.target.classList.contains('category-tile')) {
                that.onCategoryTileClick.call(that, e);
            }
        }, true);
    }, {
        //カテゴリの移動を定義します
        onCategoryTileClick: function (e) {
            var semanticZoomElement = document.getElementById('semanticzoom-container');
            if (!semanticZoomElement || !semanticZoomElement.winControl) {
                console.log('WinJS.UI.SemanticZoomコントロールがドキュメント内に見つかりませんでした。');
                return;
            }
            var clickableTile = e.target;
            var targetSelector = clickableTile.getAttribute(ZoomOutCategoryList.categoryNameAttribute);
            if (targetSelector) {
                semanticZoomElement.winControl.zoomedOut = false;
                var categoryLinkElement = document.querySelector(targetSelector);
                if (!categoryLinkElement) {
                    console.log('移動先のカテゴリ要素が取得できません。' + categoryName + 'クラスの要素がドキュメント上に存在していません。');
                    return;
                }
                this.scrollTo(categoryLinkElement);
            } else {
                console.log('移動先のカテゴリクラス名が取得できません。目的のカテゴリに移動させるには、' +
                    'category-tileクラスの要素に' + ZoomOutCategoryList.categoryNameAttribute + '属性を定義します。');
            }
        },

        scrollTo: function (element) {
            var landscapeScrollContainer = document.querySelector(ZoomOutCategoryList.scrollContainerSelector);
            if (!landscapeScrollContainer) {
                console.log('スクロールコンテナー要素が見つかりません。' +
                    ZoomOutCategoryList.scrollContainerSelector + 'クラスの要素がドキュメントに存在しているか確認してください。');
                return;
            }
            landscapeScrollContainer.scrollTop = element.offsetTop;
            landscapeScrollContainer.scrollLeft = element.offsetLeft;
        }
    }, {
        scrollContainerSelector: '.scroll-container',
        categoryNameAttribute: 'data-jump-to'
    });

    return WinJS.Namespace.define('App.UI', {
        ZoomInCategoryList: ZoomInCategoryList,
        ZoomOutCategoryList: ZoomOutCategoryList
    });
})();
